
//////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 2007-2018 zSpace, Inc.  All Rights Reserved.
//
//  File:       Sdk4JNI.jaja
//  Content:    Java bindings for the 4.0 zSpace SDK.
//
//////////////////////////////////////////////////////////////////////////

package com.zspace;

public class Sdk4JNI {

  //////////////////////////////////////////////////////////////////////////
  // zSpace APIs
  //////////////////////////////////////////////////////////////////////////

  // General API
  public final static native long zcInitialize();
  public final static native void zcUpdate(long context);
  public final static native void zcShutDown(long context);
  public final static native long zcGetContext(long handle);
  public final static native void zcSetTrackingEnabled(long context, boolean isEnabled);
  public final static native boolean zcIsTrackingEnabled(long context);
  public final static native void zcGetRuntimeVersion(long context, ZCRuntimeVersion version);
  public final static native int zcGetError();
  public final static native void zcClearError();
  public final static native String zcGetErrorString(int error);

  // Display API
  public final static native void zcRefreshDisplays(long context);
  public final static native int zcGetNumDisplays(long context);
  public final static native int zcGetNumDisplaysByType(long context, int displayType);
  public final static native long zcGetDisplay(long context, int x, int y);
  public final static native long zcGetDisplayByIndex(long context, int index);
  public final static native long zcGetDisplayByType(long context, int displayType, int index);
  public final static native int zcGetDisplayType(long displayHandle);
  public final static native int zcGetDisplayNumber(long displayHandle);
  public final static native int zcGetDisplayAdapterIndex(long displayHandle);
  public final static native int zcGetDisplayMonitorIndex(long displayHandle);
  public final static native String zcGetDisplayAttributeStr(long displayHandle, int attribute);
  public final static native void zcGetDisplaySize(long displayHandle, ZSVector2 size);
  public final static native void zcGetDisplayPosition(long displayHandle, ZSVector2 position);
  public final static native void zcGetDisplayNativeResolution(long displayHandle, ZSVector2 resolution);
  public final static native void zcGetDisplayAngle(long displayHandle, ZSVector3 angle);
  public final static native float zcGetDisplayVerticalRefreshRate(long displayHandle);
  public final static native boolean zcIsDisplayHardwarePresent(long displayHandle);
  public final static native void zcIntersectDisplay(long displayHandle, ZCTrackerPose pose, ZCDisplayIntersectionInfo intersectionInfo);

  public final static native long zcCreateStereoBuffer(long context, int renderer, long reserved);
  public final static native void zcDestroyStereoBuffer(long bufferHandle);
  public final static native void zcSetStereoBufferFullScreen(long bufferHandle, boolean isFullScreen);
  public final static native boolean zcIsStereoBufferFullScreen(long bufferHandle);
  public final static native void zcBeginStereoBufferFrame(long bufferHandle);
  public final static native void zcSyncStereoBuffer(long bufferHandle);

  // StereoViewport API
  public final static native long zcCreateViewport(long context);
  public final static native void zcDestroyViewport(long viewportHandle);
  public final static native void zcSetViewportPosition(long viewportHandle, int x, int y);
  public final static native void zcGetViewportPosition(long viewportHandle, ZSVector2 position);
  public final static native void zcSetViewportSize(long viewportHandle, int width, int height);
  public final static native void zcGetViewportSize(long viewportHandle, ZSVector2 size);

  // Coordinate Space API
  public final static native void zcGetCoordinateSpaceTransform(long viewportHandle, int a, int b, float[] transform);
  public final static native void zcTransformMatrix(long viewportHandle, int a, int b, float[] matrix);

  // StereoFrustum API
  public final static native long zcGetFrustum(long viewportHandle);
  public final static native void zcSetFrustumAttributeF32(long frustumHandle, int attribute, float value);
  public final static native float zcGetFrustumAttributeF32(long frustumHandle, int attribute);
  public final static native void zcSetFrustumAttributeB(long frustumHandle, int attribute, boolean value);
  public final static native boolean zcGetFrustumAttributeB(long frustumHandle, int attribute);
  public final static native void zcSetFrustumPortalMode(long frustumHandle, int portalModeFlags);
  public final static native int zcGetFrustumPortalMode(long frustumHandle);
  public final static native void zcSetFrustumCameraOffset(long frustumHandle, float x, float y, float z);
  public final static native void zcGetFrustumCameraOffset(long frustumHandle, ZSVector3 cameraOffset);
  public final static native void zcSetFrustumHeadPose(long frustumHandle, double timestamp, float[] matrix);
  public final static native double zcGetFrustumHeadPose(long frustumHandle, float[] matrix);
  public final static native void zcGetFrustumViewMatrix(long frustumHandle, int eye, float[] viewMatrix);
  public final static native void zcGetFrustumProjectionMatrix(long frustumHandle, int eye, float[] projectionMatrix);
  public final static native void zcGetFrustumBounds(long frustumHandle, int eye, ZCFrustumBounds bounds);
  public final static native void zcGetFrustumEyePosition(long frustumHandle, int eye, int coordinateSpace, ZSVector3 eyePosition);
  public final static native void zcGetFrustumCoupledBoundingBox(long frustumHandle, ZSVector3 lowerLeft, ZSVector3 upperRight);
  public final static native float zcCalculateFrustumFit(long frustumHandle, float llx, float lly, float llz, float urx, float ury, float urz, float[] matrix);
  public final static native float zcCalculateFrustumDisparity(long frustumHandle, float x, float y, float z);

  // TrackerDevice API
  public final static native int zcGetNumTrackerDevices(long context);
  public final static native long zcGetTrackerDevice(long context, int index);
  public final static native long zcGetTrackerDeviceByName(long context, String deviceName);
  public final static native void zcSetTrackerDeviceEnabled(long deviceHandle, boolean isEnabled);
  public final static native boolean zcIsTrackerDeviceEnabled(long deviceHandle);
  public final static native String zcGetTrackerDeviceName(long deviceHandle);

  // TrackerTarget API
  public final static native int zcGetNumTargets(long deviceHandle);
  public final static native int zcGetNumTargetsByType(long context, int targetType);
  public final static native long zcGetTarget(long deviceHandle, int index);
  public final static native long zcGetTargetByName(long deviceHandle, String targetName);
  public final static native long zcGetTargetByType(long context, int targetType, int index);
  public final static native String zcGetTargetName(long targetHandle);
  public final static native void zcSetTargetEnabled(long targetHandle, boolean isEnabled);
  public final static native boolean zcIsTargetEnabled(long targetHandle);
  public final static native boolean zcIsTargetVisible(long targetHandle);
  public final static native void zcSetTargetMoveEventThresholds(long targetHandle, float time, float distance, float angle);
  public final static native void zcGetTargetMoveEventThresholds(long targetHandle, ZSVector3 thresholds);
  public final static native double zcGetTargetPose(long targetHandle, float[] matrix);
  public final static native double zcGetTargetTransformedPose(long targetHandle, long viewportHandle, int coordinateSpace, float[] matrix);
  public final static native void zcSetTargetPoseBufferingEnabled(long targetHandle, boolean isPoseBufferingEnabled);
  public final static native boolean zcIsTargetPoseBufferingEnabled(long targetHandle);
  public final static native int zcGetTargetPoseBuffer(long targetHandle, float minDelta, float maxDelta, ZCTrackerPose[] buffer);
  public final static native void zcResizeTargetPoseBuffer(long targetHandle, int capacity);
  public final static native int zcGetTargetPoseBufferCapacity(long targetHandle);

  // TrackerTarget Button API
  public final static native int zcGetNumTargetButtons(long targetHandle);
  public final static native boolean zcIsTargetButtonPressed(long targetHandle, int buttonId);

  // TrackerTarget Led API
  public final static native void zcSetTargetLedEnabled(long targetHandle, boolean isLedEnabled);
  public final static native boolean zcIsTargetLedEnabled(long targetHandle);
  public final static native boolean zcIsTargetLedOn(long targetHandle);
  public final static native void zcSetTargetLedColor(long targetHandle, float r, float g, float b);
  public final static native void zcGetTargetLedColor(long targetHandle, ZSVector3 color);

  // TrackerTarget Vibration API
  public final static native void zcSetTargetVibrationEnabled(long targetHandle, boolean isVibrationEnabled);
  public final static native boolean zcIsTargetVibrationEnabled(long targetHandle);
  public final static native boolean zcIsTargetVibrating(long targetHandle);
  public final static native void zcStartTargetVibration(long targetHandle, float onPeriod, float offPeriod, int numTimes, float intensity);
  public final static native void zcStopTargetVibration(long targetHandle);

  // TrackerTarget Tap API
  public final static native boolean zcIsTargetTapPressed(long targetHandle);
  public final static native void zcSetTargetTapHoldThreshold(long targetHandle, float seconds);
  public final static native float zcGetTargetTapHoldThreshold(long targetHandle);

  // Tracker Event API
  public final static native void getEvents(java.util.ArrayList<ZCTrackerEventData> events);
  public final static native void zcAddTrackerEventHandler(long targetHandle, int trackerEventType, ZCEventListener trackerEventListener, Object userData);
  public final static native void zcRemoveTrackerEventHandler(long targetHandle, int trackerEventType, ZCEventListener trackerEventListener, Object userData);

  // Mouse Emulation API
  public final static native void zcSetMouseEmulationEnabled(long context, boolean isEnabled);
  public final static native boolean  zcIsMouseEmulationEnabled(long context);
  public final static native void  zcSetMouseEmulationTarget(long context, long targetHandle);
  public final static native long  zcGetMouseEmulationTarget(long context);
  public final static native void  zcSetMouseEmulationMovementMode(long context, int movementMode);
  public final static native int zcGetMouseEmulationMovementMode(long context);
  public final static native void  zcSetMouseEmulationMaxDistance(long context, float maxDistance);
  public final static native float  zcGetMouseEmulationMaxDistance(long context);
  public final static native void  zcSetMouseEmulationButtonMapping(long context, int buttonId, int mouseButton);
  public final static native int zcGetMouseEmulationButtonMapping(long context, int buttonId);
}
